#if MODE == MODE_MOUSE
void mouseClick() {
  if (RightClick) {
    DigiMouse.setButtons(2);  //right button
  } else {
    DigiMouse.setButtons(1);  //left button
  }
}

void mouseAction() {
  mouseClick();
  DigiMouse.delay(Interval);
  DigiMouse.setButtons(0);  //unclick all
    
  if (DoubleClick) {
    digitalWrite(PinLed, LOW);
    DigiMouse.delay(Interval);
    digitalWrite(PinLed, HIGH);
    mouseClick();  
    DigiMouse.delay(Interval);
    DigiMouse.setButtons(0);  //unclick all
  }
  digitalWrite(PinLed, LOW);
}
#endif

void loop() {
  switch (InType) {
    case INTYPE_SWITCH:
    case INTYPE_DIGITAL:
      inputHist = ((inputHist << 1) + digitalRead(PinSw)) & CheckHist;
      break;
  }

  if (inputHist == 0 && !lastSw) {  // HIGH→LOW
#if MODE == MODE_KEY
    switch (TriggerAct) {
      case ACT_DIRECT:
        digitalWrite(PinLed, HIGH);
        DigiKeyboard.sendKeyPress(SendCode, SendModif);
        break;
      case ACT_FALL:
        digitalWrite(PinLed, HIGH);
        DigiKeyboard.sendKeyStroke(SendCode, SendModif);
        DigiKeyboard.delay(Interval);
        digitalWrite(PinLed, LOW);
        break;
    }
#endif
#if MODE == MODE_MOUSE
    digitalWrite(PinLed, HIGH);
    switch (TriggerAct) {
      case ACT_DIRECT:
        mouseClick();  
        break;
      case ACT_FALL:
        mouseAction();
        break;
    }
#endif
    lastSw = true;
  }
  if (inputHist == CheckHist && lastSw) {  // LOW→HIGH

#if MODE == MODE_KEY
    switch (TriggerAct) {
      case ACT_DIRECT:
        DigiKeyboard.sendKeyPress(0, 0);
        digitalWrite(PinLed, LOW);
        break;
      case ACT_RISE:
        digitalWrite(PinLed, HIGH);
        DigiKeyboard.sendKeyStroke(SendCode, SendModif);
        DigiKeyboard.delay(Interval);
        digitalWrite(PinLed, LOW);
        break;
    }
#endif
#if MODE == MODE_MOUSE
    switch (TriggerAct) {
      case ACT_DIRECT:
        DigiMouse.setButtons(0);  //unclick all
        digitalWrite(PinLed, LOW);
        break;
      case ACT_RISE:
        mouseAction();
    }
#endif
    lastSw = false;
  }
#if MODE == MODE_KEY
  DigiKeyboard.delay(10);
#endif
#if MODE == MODE_MOUSE
  DigiMouse.delay(10);
#endif

#if MODE == MODE_DEBUG
  DigiUSB.print(inputHist);
  DigiUSB.print("  ");
  DigiUSB.delay(500);
#endif
}
